// CCriticalSection Class Definition
// Copyright 2006, Mike Stefanik. All rights reserved.
//
// This material may be freely redistributed and used but may not be
// republished or sold without permission.
//
#ifndef _CCRITICALSECTION_CLASS_INC
#define _CCRITICALSECTION_CLASS_INC

// Win32 critical section structure 
struct CRITICAL_SECTION
{
	unsigned int Reserved1;
	unsigned int Reserved2;
	unsigned int Reserved3;
	unsigned int Reserved4;
	unsigned int Reserved5;
	unsigned int Reserved6;
}

class CCriticalSection
{
	// Class constructor and destructor
	declare CCriticalSection();
	declare _CCriticalSection();

	// Class public methods
	declare IsLocked(), int;
	declare Lock(opt int bBlocking = true), int;
	declare Unlock();

	// Class member variables
	CRITICAL_SECTION m_cs;
	int m_nLockCount;
}

#endif // _CCRITICALSECTION_CLASS_INC
